//
// Maurice Ribble
// 2-05-2006
//
// This is a driver for the a some wheel watcher hardare.  You can find
// the design for this hardware at http://robots.glacialwanderer.com.
//


//
// Distance fudge is a fudge factor you apply to the _gWCount to figure
// out how far you have traveled.  You will need to change this depending
// on the size of your wheel, the number of slices your wheel watcher template
// has, and the units you want readDistanceTraveled() to return.
//
#define DISTANCE_FUDGE 1.2f

int1  _gW0State;
int1  _gW1State;
float _gW0Count = 0;
float _gW1Count = 0;

#INT_EXT
void ext_isr()
{
    _gW0Count += 1;
    if(_gW0State == 0)
    {
        printf("INT_EXT currently 0 on count %f\n", _gW0Count);
        _gW0State = 1;
        ext_int_edge(0, H_TO_L);
    }
    else
    {
        printf("INT_EXT currently 1 on count %f\n", _gW0Count);
        _gW0State = 0;
        ext_int_edge(0, L_TO_H);
    }
}

#INT_EXT1
void ext1_isr()
{
    _gW1Count += 1;
    if(_gW1State == 0)
    {
        printf("INT1_EXT currently 0 on count %f\n", _gW1Count);
        _gW1State = 1;
        ext_int_edge(1, H_TO_L);
    }
    else
    {
        printf("INT1_EXT currently 1 on count %f\n", _gW1Count);
        _gW1State = 0;
        ext_int_edge(1, L_TO_H);
    }
}

void setupWheelWatchers()
{
    _gW0State = input(PIN_B0);
    if(_gW0State == 0)
    {
        ext_int_edge(0, L_TO_H);
        printf("INT_EXT started out 0\n\n");
    }
    else
    {
        printf("INT_EXT started out 1\n\n");
        ext_int_edge(0, H_TO_L);
    }
    enable_interrupts(INT_EXT);

    _gW1State = input(PIN_B1);
    if(_gW1State == 0)
    {
        ext_int_edge(1, L_TO_H);
        printf("INT1_EXT started out 0\n\n");
    }
    else
    {
        printf("INT_EXT1 started out 1\n\n");
        ext_int_edge(1, H_TO_L);
    }
    enable_interrupts(INT_EXT1);
    
    enable_interrupts(GLOBAL);
}

void clearDistanceTraveled()
{
    _gW0Count = 0;
    _gW1Count = 1;
}

void readDistanceTraveled(float &wheel1, float &wheel2)
{
    wheel1 = _gW0Count * DISTANCE_FUDGE;
    wheel2 = _gW0Count * DISTANCE_FUDGE;
}
